; Azimut Project
; Copyright  2008 Philippe Coulombe. All rights reserved.

.486
.MODEL FLAT,STDCALL
OPTION CASEMAP:NONE


.NOLIST
INCLUDE AZIMUT.INC

INCLUDE advapi32.inc
INCLUDE kernel32.inc
INCLUDE ntdll.inc
INCLUDE psapi.inc
INCLUDE shlwapi.inc

INCLUDELIB advapi32.lib
INCLUDELIB kernel32.lib
INCLUDELIB ntdll.lib
INCLUDELIB psapi.lib
INCLUDELIB shlwapi.lib
.LIST


.DATA

ALIGN 4
AzmtStr szFldrPath  ,WORD, <c:\program files\xerox/0>


.CODE

Main:

    push offset szFldrPath
    call AzmtWfpUnprotectFolder
    invoke ExitProcess, eax

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ALIGN 16

;
; Disables the Windows File Protection on a specific
; folder including subfolders
;
; Windows 2000/XP/2003 only
;
; Returns the number of handles that were closed or zero if it fails
; A failure could mean that the folder was not protected
;
; p_lpwszFldrPath = Pointer of the folder path (Unicode)
;
AzmtWfpUnprotectFolder PROC USES esi edi ebx p_lpwszFldrPath:DWORD

    LOCAL l_dwRetCode:DWORD
    LOCAL l_wszFolderPath[MAX_PATH*2]:WORD
    LOCAL l_hToken:DWORD
    LOCAL l_luid:LUID
    LOCAL l_tp:TOKEN_PRIVILEGES
    LOCAL l_lpMem:DWORD
    LOCAL l_dwMemSize:DWORD
    LOCAL l_dwTmpSize:DWORD
    LOCAL l_hProcess:DWORD
    LOCAL l_dwWinlogonPid:DWORD
    LOCAL l_hWinlogon:DWORD
    LOCAL l_hCopy:DWORD
    LOCAL l_oni:OBJECT_NAME_INFORMATION
    LOCAL l_wszWinlogonPath[MAX_PATH+12]:WORD
    LOCAL l_wszBuffer[MAX_PATH+12]:WORD

    .DATA
        AzmtStr wszSeDebugPrivilege, WORD, <SeDebugPrivilege/0>
        AzmtStr wszWinlogon, WORD, <\winlogon.exe/0>
    .CODE

    mov l_dwRetCode, 0

    ;
    ; Change the drive letter from the target folder path to
    ; a device name like \Device\HarddiskVolume?
    ;

    mov esi, p_lpwszFldrPath
    lea edi, l_wszBuffer
    lea ebx, l_wszFolderPath

    cmp word ptr [esi+2], ':'
    jne @WfpErrorExit
    cmp word ptr [esi+4], '\'
    jne @WfpErrorExit

    mov ecx, dword ptr [esi]
    mov dword ptr [edi], ecx
    mov word ptr [edi+4], 0

    invoke QueryDosDeviceW, edi, ebx, MAX_PATH
    test eax, eax
    jz @WfpErrorExit

    add esi, 4
    invoke lstrcatW, ebx, esi

    ;
    ; Set process privilege required
    ;

    invoke GetCurrentProcess
    lea ecx, l_hToken
    invoke OpenProcessToken, eax, (TOKEN_ADJUST_PRIVILEGES or TOKEN_QUERY), ecx
    test eax, eax
    jz @WfpErrorExit

    invoke LookupPrivilegeValueW, NULL, addr wszSeDebugPrivilege, addr l_luid
    test eax, eax
    jz @WfpErrorToken

    mov eax, l_luid.LowPart
    mov ecx, l_luid.HighPart
    mov l_tp.PrivilegeCount, 1
    mov l_tp.Privileges.Luid.LowPart, eax
    mov l_tp.Privileges.Luid.HighPart, ecx
    mov l_tp.Privileges.Attributes, SE_PRIVILEGE_ENABLED

    invoke AdjustTokenPrivileges, l_hToken, FALSE, addr l_tp, sizeof l_tp, NULL, NULL
    test eax, eax
    jz @WfpErrorToken

    invoke CloseHandle, l_hToken

    ;
    ; Get an array of process id
    ;

    mov l_dwTmpSize, 256
    lea ebx, l_dwMemSize
    jmp @F

Get_Pid_Array:

    invoke LocalFree, l_lpMem
    add l_dwTmpSize, 256

@@:
    invoke LocalAlloc, LMEM_FIXED, l_dwTmpSize
    test eax, eax
    jz @WfpErrorExit

    mov l_lpMem, eax

    invoke EnumProcesses, l_lpMem, l_dwTmpSize, ebx
    test eax, eax
    jz @WfpErrorMemory

    mov eax, dword ptr [ebx]
    cmp eax, l_dwTmpSize
    je Get_Pid_Array

    ;
    ; Get the process id of winlogon.exe
    ;

    lea ebx, l_wszWinlogonPath
    lea edi, l_wszBuffer
    mov esi, l_lpMem

    mov word ptr [ebx], '\'
    mov word ptr [ebx+2], '?'
    mov word ptr [ebx+4], '?'
    mov word ptr [ebx+6], '\'
    lea eax, [ebx+8]
    invoke GetSystemDirectoryW, eax, MAX_PATH
    invoke lstrcatW, ebx, addr wszWinlogon
    jmp @F

Get_Winlogon_Pid:

    add esi, 4
    sub l_dwMemSize, 4
    jz @WfpErrorMemory

@@:
    invoke OpenProcess, (PROCESS_QUERY_INFORMATION or PROCESS_VM_READ), FALSE, dword ptr [esi]
    test eax, eax
    jz Get_Winlogon_Pid

    mov l_hProcess, eax
    mov word ptr [edi], 0

    invoke GetModuleFileNameExW, eax, NULL, edi, MAX_PATH
    invoke CloseHandle, l_hProcess

    invoke lstrcmpiW, addr l_wszWinlogonPath, edi
    test eax, eax
    jnz Get_Winlogon_Pid

    mov eax, dword ptr [esi]
    mov l_dwWinlogonPid, eax

    invoke LocalFree, l_lpMem

    ;
    ; Get system handle information
    ;

    lea ebx, l_dwMemSize
    mov dword ptr [ebx], 4096

    invoke LocalAlloc, LMEM_FIXED, dword ptr [ebx]
    test eax, eax
    jz @WfpErrorExit

    mov l_lpMem, eax

    invoke NtQuerySystemInformation, SystemHandleInformation, l_lpMem, dword ptr [ebx], ebx
    cmp eax, STATUS_SUCCESS
    je @F

    invoke LocalFree, l_lpMem
    invoke LocalAlloc, LMEM_FIXED, dword ptr [ebx]
    test eax, eax
    jz @WfpErrorExit

    mov l_lpMem, eax

    invoke NtQuerySystemInformation, SystemHandleInformation, l_lpMem, dword ptr [ebx], ebx
    cmp eax, STATUS_SUCCESS
    jne @WfpErrorMemory

    ;
    ; Search handles for the ones we need to close
    ;

@@:
    invoke GetCurrentProcess
    mov l_hProcess, eax

    invoke OpenProcess, PROCESS_DUP_HANDLE, FALSE, l_dwWinlogonPid
    test eax, eax
    jz @WfpErrorMemory

    mov l_hWinlogon, eax

    mov esi, l_lpMem
    mov edi, [esi].SYSTEMHANDLEINFO.nHandleEntries
    lea esi, [esi].SYSTEMHANDLEINFO.HandleInfo
    mov ebx, l_dwWinlogonPid
    jmp @F

Search_Handle:

    sub edi, 1
    jz @WfpExit

    add esi, sizeof HANDLEINFO

@@:
    cmp [esi].HANDLEINFO.Pid, ebx
    jne Search_Handle

    movzx ecx, [esi].HANDLEINFO.HandleValue
    invoke DuplicateHandle, l_hWinlogon, ecx, l_hProcess, addr l_hCopy, NULL, FALSE, DUPLICATE_SAME_ACCESS
    test eax, eax
    jz Search_Handle

    invoke NtQueryObject, l_hCopy, ObjectNameInformation, addr l_oni, sizeof l_oni, NULL
    cmp eax, STATUS_SUCCESS
    jne @F

    invoke StrStrIW, addr l_oni.NameBuffer, addr l_wszFolderPath
    test eax, eax
    jz @F

    invoke CloseHandle, l_hCopy

    movzx ecx, [esi].HANDLEINFO.HandleValue
    invoke DuplicateHandle, l_hWinlogon, ecx, l_hProcess, addr l_hCopy, NULL, FALSE, \
                            (DUPLICATE_CLOSE_SOURCE or DUPLICATE_SAME_ACCESS)
    test eax, eax
    jz @WfpErrorWinlogon

    inc l_dwRetCode

@@:
    invoke CloseHandle, l_hCopy
    jmp Search_Handle

@WfpExit:

    invoke LocalFree, l_lpMem
    invoke CloseHandle, l_hWinlogon
    mov eax, l_dwRetCode
    ret

@WfpErrorWinlogon:

    invoke LocalFree, l_lpMem
    invoke CloseHandle, l_hWinlogon
    xor eax, eax
    ret

@WfpErrorMemory:

    invoke LocalFree, l_lpMem
    xor eax, eax
    ret

@WfpErrorToken:

    invoke CloseHandle, l_hToken
    xor eax, eax
    ret

@WfpErrorExit:

    xor eax, eax
    ret

AzmtWfpUnprotectFolder ENDP

END Main

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
